// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/BranchPoint.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__BRANCH_POINT__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__BRANCH_POINT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'id'
#include "maliput_ros_interfaces/msg/detail/branch_point_id__struct.hpp"
// Member 'road_geometry_id'
#include "maliput_ros_interfaces/msg/detail/road_geometry_id__struct.hpp"
// Member 'a_side'
// Member 'b_side'
#include "maliput_ros_interfaces/msg/detail/lane_end_set__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__BranchPoint __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__BranchPoint __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BranchPoint_
{
  using Type = BranchPoint_<ContainerAllocator>;

  explicit BranchPoint_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_init),
    road_geometry_id(_init),
    a_side(_init),
    b_side(_init)
  {
    (void)_init;
  }

  explicit BranchPoint_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc, _init),
    road_geometry_id(_alloc, _init),
    a_side(_alloc, _init),
    b_side(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _id_type =
    maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>;
  _id_type id;
  using _road_geometry_id_type =
    maliput_ros_interfaces::msg::RoadGeometryId_<ContainerAllocator>;
  _road_geometry_id_type road_geometry_id;
  using _a_side_type =
    maliput_ros_interfaces::msg::LaneEndSet_<ContainerAllocator>;
  _a_side_type a_side;
  using _b_side_type =
    maliput_ros_interfaces::msg::LaneEndSet_<ContainerAllocator>;
  _b_side_type b_side;

  // setters for named parameter idiom
  Type & set__id(
    const maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__road_geometry_id(
    const maliput_ros_interfaces::msg::RoadGeometryId_<ContainerAllocator> & _arg)
  {
    this->road_geometry_id = _arg;
    return *this;
  }
  Type & set__a_side(
    const maliput_ros_interfaces::msg::LaneEndSet_<ContainerAllocator> & _arg)
  {
    this->a_side = _arg;
    return *this;
  }
  Type & set__b_side(
    const maliput_ros_interfaces::msg::LaneEndSet_<ContainerAllocator> & _arg)
  {
    this->b_side = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__BranchPoint
    std::shared_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__BranchPoint
    std::shared_ptr<maliput_ros_interfaces::msg::BranchPoint_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BranchPoint_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->road_geometry_id != other.road_geometry_id) {
      return false;
    }
    if (this->a_side != other.a_side) {
      return false;
    }
    if (this->b_side != other.b_side) {
      return false;
    }
    return true;
  }
  bool operator!=(const BranchPoint_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BranchPoint_

// alias to use template instance with default allocator
using BranchPoint =
  maliput_ros_interfaces::msg::BranchPoint_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__BRANCH_POINT__STRUCT_HPP_
