// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/HBounds.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/h_bounds__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
maliput_ros_interfaces__msg__HBounds__init(maliput_ros_interfaces__msg__HBounds * msg)
{
  if (!msg) {
    return false;
  }
  // min
  // max
  return true;
}

void
maliput_ros_interfaces__msg__HBounds__fini(maliput_ros_interfaces__msg__HBounds * msg)
{
  if (!msg) {
    return;
  }
  // min
  // max
}

bool
maliput_ros_interfaces__msg__HBounds__are_equal(const maliput_ros_interfaces__msg__HBounds * lhs, const maliput_ros_interfaces__msg__HBounds * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // min
  if (lhs->min != rhs->min) {
    return false;
  }
  // max
  if (lhs->max != rhs->max) {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__HBounds__copy(
  const maliput_ros_interfaces__msg__HBounds * input,
  maliput_ros_interfaces__msg__HBounds * output)
{
  if (!input || !output) {
    return false;
  }
  // min
  output->min = input->min;
  // max
  output->max = input->max;
  return true;
}

maliput_ros_interfaces__msg__HBounds *
maliput_ros_interfaces__msg__HBounds__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__HBounds * msg = (maliput_ros_interfaces__msg__HBounds *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__HBounds), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__HBounds));
  bool success = maliput_ros_interfaces__msg__HBounds__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__HBounds__destroy(maliput_ros_interfaces__msg__HBounds * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__HBounds__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__HBounds__Sequence__init(maliput_ros_interfaces__msg__HBounds__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__HBounds * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__HBounds *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__HBounds), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__HBounds__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__HBounds__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__HBounds__Sequence__fini(maliput_ros_interfaces__msg__HBounds__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__HBounds__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__HBounds__Sequence *
maliput_ros_interfaces__msg__HBounds__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__HBounds__Sequence * array = (maliput_ros_interfaces__msg__HBounds__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__HBounds__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__HBounds__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__HBounds__Sequence__destroy(maliput_ros_interfaces__msg__HBounds__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__HBounds__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__HBounds__Sequence__are_equal(const maliput_ros_interfaces__msg__HBounds__Sequence * lhs, const maliput_ros_interfaces__msg__HBounds__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__HBounds__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__HBounds__Sequence__copy(
  const maliput_ros_interfaces__msg__HBounds__Sequence * input,
  maliput_ros_interfaces__msg__HBounds__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__HBounds);
    maliput_ros_interfaces__msg__HBounds * data =
      (maliput_ros_interfaces__msg__HBounds *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__HBounds__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__HBounds__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__HBounds__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
