// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/Lane.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/lane__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
// Member `left_lane`
// Member `right_lane`
#include "maliput_ros_interfaces/msg/detail/lane_id__functions.h"
// Member `segment_id`
#include "maliput_ros_interfaces/msg/detail/segment_id__functions.h"
// Member `start_branch_point_id`
// Member `finish_branch_point_id`
#include "maliput_ros_interfaces/msg/detail/branch_point_id__functions.h"
// Member `default_start_branch`
// Member `default_finish_branch`
#include "maliput_ros_interfaces/msg/detail/lane_end__functions.h"

bool
maliput_ros_interfaces__msg__Lane__init(maliput_ros_interfaces__msg__Lane * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__LaneId__init(&msg->id)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // segment_id
  if (!maliput_ros_interfaces__msg__SegmentId__init(&msg->segment_id)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // index
  // left_lane
  if (!maliput_ros_interfaces__msg__LaneId__init(&msg->left_lane)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // right_lane
  if (!maliput_ros_interfaces__msg__LaneId__init(&msg->right_lane)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // length
  // start_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__init(&msg->start_branch_point_id)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // finish_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__init(&msg->finish_branch_point_id)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // default_start_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__init(&msg->default_start_branch)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  // default_finish_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__init(&msg->default_finish_branch)) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
    return false;
  }
  return true;
}

void
maliput_ros_interfaces__msg__Lane__fini(maliput_ros_interfaces__msg__Lane * msg)
{
  if (!msg) {
    return;
  }
  // id
  maliput_ros_interfaces__msg__LaneId__fini(&msg->id);
  // segment_id
  maliput_ros_interfaces__msg__SegmentId__fini(&msg->segment_id);
  // index
  // left_lane
  maliput_ros_interfaces__msg__LaneId__fini(&msg->left_lane);
  // right_lane
  maliput_ros_interfaces__msg__LaneId__fini(&msg->right_lane);
  // length
  // start_branch_point_id
  maliput_ros_interfaces__msg__BranchPointId__fini(&msg->start_branch_point_id);
  // finish_branch_point_id
  maliput_ros_interfaces__msg__BranchPointId__fini(&msg->finish_branch_point_id);
  // default_start_branch
  maliput_ros_interfaces__msg__LaneEnd__fini(&msg->default_start_branch);
  // default_finish_branch
  maliput_ros_interfaces__msg__LaneEnd__fini(&msg->default_finish_branch);
}

bool
maliput_ros_interfaces__msg__Lane__are_equal(const maliput_ros_interfaces__msg__Lane * lhs, const maliput_ros_interfaces__msg__Lane * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__LaneId__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // segment_id
  if (!maliput_ros_interfaces__msg__SegmentId__are_equal(
      &(lhs->segment_id), &(rhs->segment_id)))
  {
    return false;
  }
  // index
  if (lhs->index != rhs->index) {
    return false;
  }
  // left_lane
  if (!maliput_ros_interfaces__msg__LaneId__are_equal(
      &(lhs->left_lane), &(rhs->left_lane)))
  {
    return false;
  }
  // right_lane
  if (!maliput_ros_interfaces__msg__LaneId__are_equal(
      &(lhs->right_lane), &(rhs->right_lane)))
  {
    return false;
  }
  // length
  if (lhs->length != rhs->length) {
    return false;
  }
  // start_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__are_equal(
      &(lhs->start_branch_point_id), &(rhs->start_branch_point_id)))
  {
    return false;
  }
  // finish_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__are_equal(
      &(lhs->finish_branch_point_id), &(rhs->finish_branch_point_id)))
  {
    return false;
  }
  // default_start_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__are_equal(
      &(lhs->default_start_branch), &(rhs->default_start_branch)))
  {
    return false;
  }
  // default_finish_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__are_equal(
      &(lhs->default_finish_branch), &(rhs->default_finish_branch)))
  {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__Lane__copy(
  const maliput_ros_interfaces__msg__Lane * input,
  maliput_ros_interfaces__msg__Lane * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__LaneId__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // segment_id
  if (!maliput_ros_interfaces__msg__SegmentId__copy(
      &(input->segment_id), &(output->segment_id)))
  {
    return false;
  }
  // index
  output->index = input->index;
  // left_lane
  if (!maliput_ros_interfaces__msg__LaneId__copy(
      &(input->left_lane), &(output->left_lane)))
  {
    return false;
  }
  // right_lane
  if (!maliput_ros_interfaces__msg__LaneId__copy(
      &(input->right_lane), &(output->right_lane)))
  {
    return false;
  }
  // length
  output->length = input->length;
  // start_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__copy(
      &(input->start_branch_point_id), &(output->start_branch_point_id)))
  {
    return false;
  }
  // finish_branch_point_id
  if (!maliput_ros_interfaces__msg__BranchPointId__copy(
      &(input->finish_branch_point_id), &(output->finish_branch_point_id)))
  {
    return false;
  }
  // default_start_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__copy(
      &(input->default_start_branch), &(output->default_start_branch)))
  {
    return false;
  }
  // default_finish_branch
  if (!maliput_ros_interfaces__msg__LaneEnd__copy(
      &(input->default_finish_branch), &(output->default_finish_branch)))
  {
    return false;
  }
  return true;
}

maliput_ros_interfaces__msg__Lane *
maliput_ros_interfaces__msg__Lane__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Lane * msg = (maliput_ros_interfaces__msg__Lane *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__Lane), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__Lane));
  bool success = maliput_ros_interfaces__msg__Lane__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__Lane__destroy(maliput_ros_interfaces__msg__Lane * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__Lane__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__Lane__Sequence__init(maliput_ros_interfaces__msg__Lane__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Lane * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__Lane *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__Lane), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__Lane__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__Lane__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__Lane__Sequence__fini(maliput_ros_interfaces__msg__Lane__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__Lane__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__Lane__Sequence *
maliput_ros_interfaces__msg__Lane__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Lane__Sequence * array = (maliput_ros_interfaces__msg__Lane__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__Lane__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__Lane__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__Lane__Sequence__destroy(maliput_ros_interfaces__msg__Lane__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__Lane__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__Lane__Sequence__are_equal(const maliput_ros_interfaces__msg__Lane__Sequence * lhs, const maliput_ros_interfaces__msg__Lane__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__Lane__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__Lane__Sequence__copy(
  const maliput_ros_interfaces__msg__Lane__Sequence * input,
  maliput_ros_interfaces__msg__Lane__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__Lane);
    maliput_ros_interfaces__msg__Lane * data =
      (maliput_ros_interfaces__msg__Lane *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__Lane__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__Lane__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__Lane__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
