// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/Lane.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'id'
// Member 'left_lane'
// Member 'right_lane'
#include "maliput_ros_interfaces/msg/detail/lane_id__struct.hpp"
// Member 'segment_id'
#include "maliput_ros_interfaces/msg/detail/segment_id__struct.hpp"
// Member 'start_branch_point_id'
// Member 'finish_branch_point_id'
#include "maliput_ros_interfaces/msg/detail/branch_point_id__struct.hpp"
// Member 'default_start_branch'
// Member 'default_finish_branch'
#include "maliput_ros_interfaces/msg/detail/lane_end__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__Lane __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__Lane __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Lane_
{
  using Type = Lane_<ContainerAllocator>;

  explicit Lane_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_init),
    segment_id(_init),
    left_lane(_init),
    right_lane(_init),
    start_branch_point_id(_init),
    finish_branch_point_id(_init),
    default_start_branch(_init),
    default_finish_branch(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->index = 0l;
      this->length = 0.0;
    }
  }

  explicit Lane_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc, _init),
    segment_id(_alloc, _init),
    left_lane(_alloc, _init),
    right_lane(_alloc, _init),
    start_branch_point_id(_alloc, _init),
    finish_branch_point_id(_alloc, _init),
    default_start_branch(_alloc, _init),
    default_finish_branch(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->index = 0l;
      this->length = 0.0;
    }
  }

  // field types and members
  using _id_type =
    maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>;
  _id_type id;
  using _segment_id_type =
    maliput_ros_interfaces::msg::SegmentId_<ContainerAllocator>;
  _segment_id_type segment_id;
  using _index_type =
    int32_t;
  _index_type index;
  using _left_lane_type =
    maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>;
  _left_lane_type left_lane;
  using _right_lane_type =
    maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>;
  _right_lane_type right_lane;
  using _length_type =
    double;
  _length_type length;
  using _start_branch_point_id_type =
    maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>;
  _start_branch_point_id_type start_branch_point_id;
  using _finish_branch_point_id_type =
    maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>;
  _finish_branch_point_id_type finish_branch_point_id;
  using _default_start_branch_type =
    maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>;
  _default_start_branch_type default_start_branch;
  using _default_finish_branch_type =
    maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>;
  _default_finish_branch_type default_finish_branch;

  // setters for named parameter idiom
  Type & set__id(
    const maliput_ros_interfaces::msg::LaneId_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__segment_id(
    const maliput_ros_interfaces::msg::SegmentId_<ContainerAllocator> & _arg)
  {
    this->segment_id = _arg;
    return *this;
  }
  Type & set__index(
    const int32_t & _arg)
  {
    this->index = _arg;
    return *this;
  }
  Type & set__left_lane(
    const maliput_ros_interfaces::msg::LaneId_<ContainerAllocator> & _arg)
  {
    this->left_lane = _arg;
    return *this;
  }
  Type & set__right_lane(
    const maliput_ros_interfaces::msg::LaneId_<ContainerAllocator> & _arg)
  {
    this->right_lane = _arg;
    return *this;
  }
  Type & set__length(
    const double & _arg)
  {
    this->length = _arg;
    return *this;
  }
  Type & set__start_branch_point_id(
    const maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator> & _arg)
  {
    this->start_branch_point_id = _arg;
    return *this;
  }
  Type & set__finish_branch_point_id(
    const maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator> & _arg)
  {
    this->finish_branch_point_id = _arg;
    return *this;
  }
  Type & set__default_start_branch(
    const maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> & _arg)
  {
    this->default_start_branch = _arg;
    return *this;
  }
  Type & set__default_finish_branch(
    const maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> & _arg)
  {
    this->default_finish_branch = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::Lane_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::Lane_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::Lane_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::Lane_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__Lane
    std::shared_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__Lane
    std::shared_ptr<maliput_ros_interfaces::msg::Lane_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Lane_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->segment_id != other.segment_id) {
      return false;
    }
    if (this->index != other.index) {
      return false;
    }
    if (this->left_lane != other.left_lane) {
      return false;
    }
    if (this->right_lane != other.right_lane) {
      return false;
    }
    if (this->length != other.length) {
      return false;
    }
    if (this->start_branch_point_id != other.start_branch_point_id) {
      return false;
    }
    if (this->finish_branch_point_id != other.finish_branch_point_id) {
      return false;
    }
    if (this->default_start_branch != other.default_start_branch) {
      return false;
    }
    if (this->default_finish_branch != other.default_finish_branch) {
      return false;
    }
    return true;
  }
  bool operator!=(const Lane_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Lane_

// alias to use template instance with default allocator
using Lane =
  maliput_ros_interfaces::msg::Lane_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE__STRUCT_HPP_
