// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from maliput_ros_interfaces:msg/RoadGeometryId.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY_ID__FUNCTIONS_H_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY_ID__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "maliput_ros_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "maliput_ros_interfaces/msg/detail/road_geometry_id__struct.h"

/// Initialize msg/RoadGeometryId message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * maliput_ros_interfaces__msg__RoadGeometryId
 * )) before or use
 * maliput_ros_interfaces__msg__RoadGeometryId__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__init(maliput_ros_interfaces__msg__RoadGeometryId * msg);

/// Finalize msg/RoadGeometryId message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
void
maliput_ros_interfaces__msg__RoadGeometryId__fini(maliput_ros_interfaces__msg__RoadGeometryId * msg);

/// Create msg/RoadGeometryId message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * maliput_ros_interfaces__msg__RoadGeometryId__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
maliput_ros_interfaces__msg__RoadGeometryId *
maliput_ros_interfaces__msg__RoadGeometryId__create();

/// Destroy msg/RoadGeometryId message.
/**
 * It calls
 * maliput_ros_interfaces__msg__RoadGeometryId__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
void
maliput_ros_interfaces__msg__RoadGeometryId__destroy(maliput_ros_interfaces__msg__RoadGeometryId * msg);

/// Check for msg/RoadGeometryId message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__are_equal(const maliput_ros_interfaces__msg__RoadGeometryId * lhs, const maliput_ros_interfaces__msg__RoadGeometryId * rhs);

/// Copy a msg/RoadGeometryId message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__copy(
  const maliput_ros_interfaces__msg__RoadGeometryId * input,
  maliput_ros_interfaces__msg__RoadGeometryId * output);

/// Initialize array of msg/RoadGeometryId messages.
/**
 * It allocates the memory for the number of elements and calls
 * maliput_ros_interfaces__msg__RoadGeometryId__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__init(maliput_ros_interfaces__msg__RoadGeometryId__Sequence * array, size_t size);

/// Finalize array of msg/RoadGeometryId messages.
/**
 * It calls
 * maliput_ros_interfaces__msg__RoadGeometryId__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
void
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__fini(maliput_ros_interfaces__msg__RoadGeometryId__Sequence * array);

/// Create array of msg/RoadGeometryId messages.
/**
 * It allocates the memory for the array and calls
 * maliput_ros_interfaces__msg__RoadGeometryId__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
maliput_ros_interfaces__msg__RoadGeometryId__Sequence *
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__create(size_t size);

/// Destroy array of msg/RoadGeometryId messages.
/**
 * It calls
 * maliput_ros_interfaces__msg__RoadGeometryId__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
void
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__destroy(maliput_ros_interfaces__msg__RoadGeometryId__Sequence * array);

/// Check for msg/RoadGeometryId message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__are_equal(const maliput_ros_interfaces__msg__RoadGeometryId__Sequence * lhs, const maliput_ros_interfaces__msg__RoadGeometryId__Sequence * rhs);

/// Copy an array of msg/RoadGeometryId messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_maliput_ros_interfaces
bool
maliput_ros_interfaces__msg__RoadGeometryId__Sequence__copy(
  const maliput_ros_interfaces__msg__RoadGeometryId__Sequence * input,
  maliput_ros_interfaces__msg__RoadGeometryId__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY_ID__FUNCTIONS_H_
