// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/RoadPositionResult.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION_RESULT__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION_RESULT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'road_position'
#include "maliput_ros_interfaces/msg/detail/road_position__struct.hpp"
// Member 'nearest_position'
#include "maliput_ros_interfaces/msg/detail/inertial_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__RoadPositionResult __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__RoadPositionResult __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadPositionResult_
{
  using Type = RoadPositionResult_<ContainerAllocator>;

  explicit RoadPositionResult_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_init),
    nearest_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance = 0.0;
    }
  }

  explicit RoadPositionResult_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_alloc, _init),
    nearest_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->distance = 0.0;
    }
  }

  // field types and members
  using _road_position_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _road_position_type road_position;
  using _nearest_position_type =
    maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>;
  _nearest_position_type nearest_position;
  using _distance_type =
    double;
  _distance_type distance;

  // setters for named parameter idiom
  Type & set__road_position(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->road_position = _arg;
    return *this;
  }
  Type & set__nearest_position(
    const maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator> & _arg)
  {
    this->nearest_position = _arg;
    return *this;
  }
  Type & set__distance(
    const double & _arg)
  {
    this->distance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadPositionResult
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadPositionResult
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadPositionResult_ & other) const
  {
    if (this->road_position != other.road_position) {
      return false;
    }
    if (this->nearest_position != other.nearest_position) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadPositionResult_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadPositionResult_

// alias to use template instance with default allocator
using RoadPositionResult =
  maliput_ros_interfaces::msg::RoadPositionResult_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION_RESULT__STRUCT_HPP_
