// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/SRange.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/s_range__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
maliput_ros_interfaces__msg__SRange__init(maliput_ros_interfaces__msg__SRange * msg)
{
  if (!msg) {
    return false;
  }
  // s0
  // s1
  // size
  // with_s
  return true;
}

void
maliput_ros_interfaces__msg__SRange__fini(maliput_ros_interfaces__msg__SRange * msg)
{
  if (!msg) {
    return;
  }
  // s0
  // s1
  // size
  // with_s
}

bool
maliput_ros_interfaces__msg__SRange__are_equal(const maliput_ros_interfaces__msg__SRange * lhs, const maliput_ros_interfaces__msg__SRange * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // s0
  if (lhs->s0 != rhs->s0) {
    return false;
  }
  // s1
  if (lhs->s1 != rhs->s1) {
    return false;
  }
  // size
  if (lhs->size != rhs->size) {
    return false;
  }
  // with_s
  if (lhs->with_s != rhs->with_s) {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__SRange__copy(
  const maliput_ros_interfaces__msg__SRange * input,
  maliput_ros_interfaces__msg__SRange * output)
{
  if (!input || !output) {
    return false;
  }
  // s0
  output->s0 = input->s0;
  // s1
  output->s1 = input->s1;
  // size
  output->size = input->size;
  // with_s
  output->with_s = input->with_s;
  return true;
}

maliput_ros_interfaces__msg__SRange *
maliput_ros_interfaces__msg__SRange__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__SRange * msg = (maliput_ros_interfaces__msg__SRange *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__SRange), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__SRange));
  bool success = maliput_ros_interfaces__msg__SRange__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__SRange__destroy(maliput_ros_interfaces__msg__SRange * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__SRange__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__SRange__Sequence__init(maliput_ros_interfaces__msg__SRange__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__SRange * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__SRange *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__SRange), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__SRange__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__SRange__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__SRange__Sequence__fini(maliput_ros_interfaces__msg__SRange__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__SRange__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__SRange__Sequence *
maliput_ros_interfaces__msg__SRange__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__SRange__Sequence * array = (maliput_ros_interfaces__msg__SRange__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__SRange__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__SRange__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__SRange__Sequence__destroy(maliput_ros_interfaces__msg__SRange__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__SRange__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__SRange__Sequence__are_equal(const maliput_ros_interfaces__msg__SRange__Sequence * lhs, const maliput_ros_interfaces__msg__SRange__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__SRange__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__SRange__Sequence__copy(
  const maliput_ros_interfaces__msg__SRange__Sequence * input,
  maliput_ros_interfaces__msg__SRange__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__SRange);
    maliput_ros_interfaces__msg__SRange * data =
      (maliput_ros_interfaces__msg__SRange *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__SRange__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__SRange__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__SRange__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
