// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/SRange.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__S_RANGE__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__S_RANGE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__SRange __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__SRange __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SRange_
{
  using Type = SRange_<ContainerAllocator>;

  explicit SRange_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->s0 = 0.0;
      this->s1 = 0.0;
      this->size = 0.0;
      this->with_s = false;
    }
  }

  explicit SRange_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->s0 = 0.0;
      this->s1 = 0.0;
      this->size = 0.0;
      this->with_s = false;
    }
  }

  // field types and members
  using _s0_type =
    double;
  _s0_type s0;
  using _s1_type =
    double;
  _s1_type s1;
  using _size_type =
    double;
  _size_type size;
  using _with_s_type =
    bool;
  _with_s_type with_s;

  // setters for named parameter idiom
  Type & set__s0(
    const double & _arg)
  {
    this->s0 = _arg;
    return *this;
  }
  Type & set__s1(
    const double & _arg)
  {
    this->s1 = _arg;
    return *this;
  }
  Type & set__size(
    const double & _arg)
  {
    this->size = _arg;
    return *this;
  }
  Type & set__with_s(
    const bool & _arg)
  {
    this->with_s = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::SRange_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::SRange_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::SRange_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::SRange_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__SRange
    std::shared_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__SRange
    std::shared_ptr<maliput_ros_interfaces::msg::SRange_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SRange_ & other) const
  {
    if (this->s0 != other.s0) {
      return false;
    }
    if (this->s1 != other.s1) {
      return false;
    }
    if (this->size != other.size) {
      return false;
    }
    if (this->with_s != other.with_s) {
      return false;
    }
    return true;
  }
  bool operator!=(const SRange_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SRange_

// alias to use template instance with default allocator
using SRange =
  maliput_ros_interfaces::msg::SRange_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__S_RANGE__STRUCT_HPP_
