// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/DeriveLaneSRoutes.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__DERIVE_LANE_S_ROUTES__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__DERIVE_LANE_S_ROUTES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'start'
// Member 'end'
#include "maliput_ros_interfaces/msg/detail/road_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeriveLaneSRoutes_Request_
{
  using Type = DeriveLaneSRoutes_Request_<ContainerAllocator>;

  explicit DeriveLaneSRoutes_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_init),
    end(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_length_m = 0.0;
    }
  }

  explicit DeriveLaneSRoutes_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_alloc, _init),
    end(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->max_length_m = 0.0;
    }
  }

  // field types and members
  using _start_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _start_type start;
  using _end_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _end_type end;
  using _max_length_m_type =
    double;
  _max_length_m_type max_length_m;

  // setters for named parameter idiom
  Type & set__start(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__end(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->end = _arg;
    return *this;
  }
  Type & set__max_length_m(
    const double & _arg)
  {
    this->max_length_m = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeriveLaneSRoutes_Request_ & other) const
  {
    if (this->start != other.start) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    if (this->max_length_m != other.max_length_m) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeriveLaneSRoutes_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeriveLaneSRoutes_Request_

// alias to use template instance with default allocator
using DeriveLaneSRoutes_Request =
  maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'lane_s_routes'
#include "maliput_ros_interfaces/msg/detail/lane_s_route__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DeriveLaneSRoutes_Response_
{
  using Type = DeriveLaneSRoutes_Response_<ContainerAllocator>;

  explicit DeriveLaneSRoutes_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit DeriveLaneSRoutes_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _lane_s_routes_type =
    std::vector<maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator>>::other>;
  _lane_s_routes_type lane_s_routes;

  // setters for named parameter idiom
  Type & set__lane_s_routes(
    const std::vector<maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator>>::other> & _arg)
  {
    this->lane_s_routes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response
    std::shared_ptr<maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DeriveLaneSRoutes_Response_ & other) const
  {
    if (this->lane_s_routes != other.lane_s_routes) {
      return false;
    }
    return true;
  }
  bool operator!=(const DeriveLaneSRoutes_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DeriveLaneSRoutes_Response_

// alias to use template instance with default allocator
using DeriveLaneSRoutes_Response =
  maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct DeriveLaneSRoutes
{
  using Request = maliput_ros_interfaces::srv::DeriveLaneSRoutes_Request;
  using Response = maliput_ros_interfaces::srv::DeriveLaneSRoutes_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__DERIVE_LANE_S_ROUTES__STRUCT_HPP_
