// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/LaneBoundaries.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__LANE_BOUNDARIES__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__LANE_BOUNDARIES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'road_position'
#include "maliput_ros_interfaces/msg/detail/road_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct LaneBoundaries_Request_
{
  using Type = LaneBoundaries_Request_<ContainerAllocator>;

  explicit LaneBoundaries_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_init)
  {
    (void)_init;
  }

  explicit LaneBoundaries_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_position_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _road_position_type road_position;

  // setters for named parameter idiom
  Type & set__road_position(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->road_position = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Request
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Request
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaneBoundaries_Request_ & other) const
  {
    if (this->road_position != other.road_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaneBoundaries_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaneBoundaries_Request_

// alias to use template instance with default allocator
using LaneBoundaries_Request =
  maliput_ros_interfaces::srv::LaneBoundaries_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'lane_bounds'
// Member 'segment_bounds'
#include "maliput_ros_interfaces/msg/detail/r_bounds__struct.hpp"
// Member 'elevation_bounds'
#include "maliput_ros_interfaces/msg/detail/h_bounds__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct LaneBoundaries_Response_
{
  using Type = LaneBoundaries_Response_<ContainerAllocator>;

  explicit LaneBoundaries_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_bounds(_init),
    segment_bounds(_init),
    elevation_bounds(_init)
  {
    (void)_init;
  }

  explicit LaneBoundaries_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_bounds(_alloc, _init),
    segment_bounds(_alloc, _init),
    elevation_bounds(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _lane_bounds_type =
    maliput_ros_interfaces::msg::RBounds_<ContainerAllocator>;
  _lane_bounds_type lane_bounds;
  using _segment_bounds_type =
    maliput_ros_interfaces::msg::RBounds_<ContainerAllocator>;
  _segment_bounds_type segment_bounds;
  using _elevation_bounds_type =
    maliput_ros_interfaces::msg::HBounds_<ContainerAllocator>;
  _elevation_bounds_type elevation_bounds;

  // setters for named parameter idiom
  Type & set__lane_bounds(
    const maliput_ros_interfaces::msg::RBounds_<ContainerAllocator> & _arg)
  {
    this->lane_bounds = _arg;
    return *this;
  }
  Type & set__segment_bounds(
    const maliput_ros_interfaces::msg::RBounds_<ContainerAllocator> & _arg)
  {
    this->segment_bounds = _arg;
    return *this;
  }
  Type & set__elevation_bounds(
    const maliput_ros_interfaces::msg::HBounds_<ContainerAllocator> & _arg)
  {
    this->elevation_bounds = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Response
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__LaneBoundaries_Response
    std::shared_ptr<maliput_ros_interfaces::srv::LaneBoundaries_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaneBoundaries_Response_ & other) const
  {
    if (this->lane_bounds != other.lane_bounds) {
      return false;
    }
    if (this->segment_bounds != other.segment_bounds) {
      return false;
    }
    if (this->elevation_bounds != other.elevation_bounds) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaneBoundaries_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaneBoundaries_Response_

// alias to use template instance with default allocator
using LaneBoundaries_Response =
  maliput_ros_interfaces::srv::LaneBoundaries_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct LaneBoundaries
{
  using Request = maliput_ros_interfaces::srv::LaneBoundaries_Request;
  using Response = maliput_ros_interfaces::srv::LaneBoundaries_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__LANE_BOUNDARIES__STRUCT_HPP_
