// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/SampleLaneSRoute.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__SAMPLE_LANE_S_ROUTE__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__SAMPLE_LANE_S_ROUTE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'lane_s_route'
#include "maliput_ros_interfaces/msg/detail/lane_s_route__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SampleLaneSRoute_Request_
{
  using Type = SampleLaneSRoute_Request_<ContainerAllocator>;

  explicit SampleLaneSRoute_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_s_route(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_length_sampling_rate = 0.0;
    }
  }

  explicit SampleLaneSRoute_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_s_route(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->path_length_sampling_rate = 0.0;
    }
  }

  // field types and members
  using _lane_s_route_type =
    maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator>;
  _lane_s_route_type lane_s_route;
  using _path_length_sampling_rate_type =
    double;
  _path_length_sampling_rate_type path_length_sampling_rate;

  // setters for named parameter idiom
  Type & set__lane_s_route(
    const maliput_ros_interfaces::msg::LaneSRoute_<ContainerAllocator> & _arg)
  {
    this->lane_s_route = _arg;
    return *this;
  }
  Type & set__path_length_sampling_rate(
    const double & _arg)
  {
    this->path_length_sampling_rate = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Request
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Request
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SampleLaneSRoute_Request_ & other) const
  {
    if (this->lane_s_route != other.lane_s_route) {
      return false;
    }
    if (this->path_length_sampling_rate != other.path_length_sampling_rate) {
      return false;
    }
    return true;
  }
  bool operator!=(const SampleLaneSRoute_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SampleLaneSRoute_Request_

// alias to use template instance with default allocator
using SampleLaneSRoute_Request =
  maliput_ros_interfaces::srv::SampleLaneSRoute_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'waypoints'
#include "maliput_ros_interfaces/msg/detail/inertial_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SampleLaneSRoute_Response_
{
  using Type = SampleLaneSRoute_Response_<ContainerAllocator>;

  explicit SampleLaneSRoute_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit SampleLaneSRoute_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _waypoints_type =
    std::vector<maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>>::other>;
  _waypoints_type waypoints;

  // setters for named parameter idiom
  Type & set__waypoints(
    const std::vector<maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>>::other> & _arg)
  {
    this->waypoints = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Response
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__SampleLaneSRoute_Response
    std::shared_ptr<maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SampleLaneSRoute_Response_ & other) const
  {
    if (this->waypoints != other.waypoints) {
      return false;
    }
    return true;
  }
  bool operator!=(const SampleLaneSRoute_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SampleLaneSRoute_Response_

// alias to use template instance with default allocator
using SampleLaneSRoute_Response =
  maliput_ros_interfaces::srv::SampleLaneSRoute_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct SampleLaneSRoute
{
  using Request = maliput_ros_interfaces::srv::SampleLaneSRoute_Request;
  using Response = maliput_ros_interfaces::srv::SampleLaneSRoute_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__SAMPLE_LANE_S_ROUTE__STRUCT_HPP_
