// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/BranchPoint.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/branch_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
#include "maliput_ros_interfaces/msg/detail/branch_point_id__functions.h"
// Member `road_geometry_id`
#include "maliput_ros_interfaces/msg/detail/road_geometry_id__functions.h"
// Member `a_side`
// Member `b_side`
#include "maliput_ros_interfaces/msg/detail/lane_end_set__functions.h"

bool
maliput_ros_interfaces__msg__BranchPoint__init(maliput_ros_interfaces__msg__BranchPoint * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__BranchPointId__init(&msg->id)) {
    maliput_ros_interfaces__msg__BranchPoint__fini(msg);
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__init(&msg->road_geometry_id)) {
    maliput_ros_interfaces__msg__BranchPoint__fini(msg);
    return false;
  }
  // a_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__init(&msg->a_side)) {
    maliput_ros_interfaces__msg__BranchPoint__fini(msg);
    return false;
  }
  // b_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__init(&msg->b_side)) {
    maliput_ros_interfaces__msg__BranchPoint__fini(msg);
    return false;
  }
  return true;
}

void
maliput_ros_interfaces__msg__BranchPoint__fini(maliput_ros_interfaces__msg__BranchPoint * msg)
{
  if (!msg) {
    return;
  }
  // id
  maliput_ros_interfaces__msg__BranchPointId__fini(&msg->id);
  // road_geometry_id
  maliput_ros_interfaces__msg__RoadGeometryId__fini(&msg->road_geometry_id);
  // a_side
  maliput_ros_interfaces__msg__LaneEndSet__fini(&msg->a_side);
  // b_side
  maliput_ros_interfaces__msg__LaneEndSet__fini(&msg->b_side);
}

bool
maliput_ros_interfaces__msg__BranchPoint__are_equal(const maliput_ros_interfaces__msg__BranchPoint * lhs, const maliput_ros_interfaces__msg__BranchPoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__BranchPointId__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__are_equal(
      &(lhs->road_geometry_id), &(rhs->road_geometry_id)))
  {
    return false;
  }
  // a_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__are_equal(
      &(lhs->a_side), &(rhs->a_side)))
  {
    return false;
  }
  // b_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__are_equal(
      &(lhs->b_side), &(rhs->b_side)))
  {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__BranchPoint__copy(
  const maliput_ros_interfaces__msg__BranchPoint * input,
  maliput_ros_interfaces__msg__BranchPoint * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__BranchPointId__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__copy(
      &(input->road_geometry_id), &(output->road_geometry_id)))
  {
    return false;
  }
  // a_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__copy(
      &(input->a_side), &(output->a_side)))
  {
    return false;
  }
  // b_side
  if (!maliput_ros_interfaces__msg__LaneEndSet__copy(
      &(input->b_side), &(output->b_side)))
  {
    return false;
  }
  return true;
}

maliput_ros_interfaces__msg__BranchPoint *
maliput_ros_interfaces__msg__BranchPoint__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__BranchPoint * msg = (maliput_ros_interfaces__msg__BranchPoint *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__BranchPoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__BranchPoint));
  bool success = maliput_ros_interfaces__msg__BranchPoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__BranchPoint__destroy(maliput_ros_interfaces__msg__BranchPoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__BranchPoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__BranchPoint__Sequence__init(maliput_ros_interfaces__msg__BranchPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__BranchPoint * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__BranchPoint *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__BranchPoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__BranchPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__BranchPoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__BranchPoint__Sequence__fini(maliput_ros_interfaces__msg__BranchPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__BranchPoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__BranchPoint__Sequence *
maliput_ros_interfaces__msg__BranchPoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__BranchPoint__Sequence * array = (maliput_ros_interfaces__msg__BranchPoint__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__BranchPoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__BranchPoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__BranchPoint__Sequence__destroy(maliput_ros_interfaces__msg__BranchPoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__BranchPoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__BranchPoint__Sequence__are_equal(const maliput_ros_interfaces__msg__BranchPoint__Sequence * lhs, const maliput_ros_interfaces__msg__BranchPoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__BranchPoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__BranchPoint__Sequence__copy(
  const maliput_ros_interfaces__msg__BranchPoint__Sequence * input,
  maliput_ros_interfaces__msg__BranchPoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__BranchPoint);
    maliput_ros_interfaces__msg__BranchPoint * data =
      (maliput_ros_interfaces__msg__BranchPoint *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__BranchPoint__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__BranchPoint__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__BranchPoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
