// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/IsoLaneVelocity.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__ISO_LANE_VELOCITY__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__ISO_LANE_VELOCITY__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__IsoLaneVelocity __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__IsoLaneVelocity __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IsoLaneVelocity_
{
  using Type = IsoLaneVelocity_<ContainerAllocator>;

  explicit IsoLaneVelocity_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sigma_v = 0.0;
      this->rho_v = 0.0;
      this->eta_v = 0.0;
    }
  }

  explicit IsoLaneVelocity_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->sigma_v = 0.0;
      this->rho_v = 0.0;
      this->eta_v = 0.0;
    }
  }

  // field types and members
  using _sigma_v_type =
    double;
  _sigma_v_type sigma_v;
  using _rho_v_type =
    double;
  _rho_v_type rho_v;
  using _eta_v_type =
    double;
  _eta_v_type eta_v;

  // setters for named parameter idiom
  Type & set__sigma_v(
    const double & _arg)
  {
    this->sigma_v = _arg;
    return *this;
  }
  Type & set__rho_v(
    const double & _arg)
  {
    this->rho_v = _arg;
    return *this;
  }
  Type & set__eta_v(
    const double & _arg)
  {
    this->eta_v = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__IsoLaneVelocity
    std::shared_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__IsoLaneVelocity
    std::shared_ptr<maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IsoLaneVelocity_ & other) const
  {
    if (this->sigma_v != other.sigma_v) {
      return false;
    }
    if (this->rho_v != other.rho_v) {
      return false;
    }
    if (this->eta_v != other.eta_v) {
      return false;
    }
    return true;
  }
  bool operator!=(const IsoLaneVelocity_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IsoLaneVelocity_

// alias to use template instance with default allocator
using IsoLaneVelocity =
  maliput_ros_interfaces::msg::IsoLaneVelocity_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__ISO_LANE_VELOCITY__STRUCT_HPP_
