// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/Junction.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/junction__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
#include "maliput_ros_interfaces/msg/detail/junction_id__functions.h"
// Member `road_geometry_id`
#include "maliput_ros_interfaces/msg/detail/road_geometry_id__functions.h"
// Member `segment_ids`
#include "maliput_ros_interfaces/msg/detail/segment_id__functions.h"

bool
maliput_ros_interfaces__msg__Junction__init(maliput_ros_interfaces__msg__Junction * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__JunctionId__init(&msg->id)) {
    maliput_ros_interfaces__msg__Junction__fini(msg);
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__init(&msg->road_geometry_id)) {
    maliput_ros_interfaces__msg__Junction__fini(msg);
    return false;
  }
  // segment_ids
  if (!maliput_ros_interfaces__msg__SegmentId__Sequence__init(&msg->segment_ids, 0)) {
    maliput_ros_interfaces__msg__Junction__fini(msg);
    return false;
  }
  return true;
}

void
maliput_ros_interfaces__msg__Junction__fini(maliput_ros_interfaces__msg__Junction * msg)
{
  if (!msg) {
    return;
  }
  // id
  maliput_ros_interfaces__msg__JunctionId__fini(&msg->id);
  // road_geometry_id
  maliput_ros_interfaces__msg__RoadGeometryId__fini(&msg->road_geometry_id);
  // segment_ids
  maliput_ros_interfaces__msg__SegmentId__Sequence__fini(&msg->segment_ids);
}

bool
maliput_ros_interfaces__msg__Junction__are_equal(const maliput_ros_interfaces__msg__Junction * lhs, const maliput_ros_interfaces__msg__Junction * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__JunctionId__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__are_equal(
      &(lhs->road_geometry_id), &(rhs->road_geometry_id)))
  {
    return false;
  }
  // segment_ids
  if (!maliput_ros_interfaces__msg__SegmentId__Sequence__are_equal(
      &(lhs->segment_ids), &(rhs->segment_ids)))
  {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__Junction__copy(
  const maliput_ros_interfaces__msg__Junction * input,
  maliput_ros_interfaces__msg__Junction * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  if (!maliput_ros_interfaces__msg__JunctionId__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // road_geometry_id
  if (!maliput_ros_interfaces__msg__RoadGeometryId__copy(
      &(input->road_geometry_id), &(output->road_geometry_id)))
  {
    return false;
  }
  // segment_ids
  if (!maliput_ros_interfaces__msg__SegmentId__Sequence__copy(
      &(input->segment_ids), &(output->segment_ids)))
  {
    return false;
  }
  return true;
}

maliput_ros_interfaces__msg__Junction *
maliput_ros_interfaces__msg__Junction__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Junction * msg = (maliput_ros_interfaces__msg__Junction *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__Junction), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__Junction));
  bool success = maliput_ros_interfaces__msg__Junction__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__Junction__destroy(maliput_ros_interfaces__msg__Junction * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__Junction__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__Junction__Sequence__init(maliput_ros_interfaces__msg__Junction__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Junction * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__Junction *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__Junction), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__Junction__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__Junction__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__Junction__Sequence__fini(maliput_ros_interfaces__msg__Junction__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__Junction__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__Junction__Sequence *
maliput_ros_interfaces__msg__Junction__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__Junction__Sequence * array = (maliput_ros_interfaces__msg__Junction__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__Junction__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__Junction__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__Junction__Sequence__destroy(maliput_ros_interfaces__msg__Junction__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__Junction__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__Junction__Sequence__are_equal(const maliput_ros_interfaces__msg__Junction__Sequence * lhs, const maliput_ros_interfaces__msg__Junction__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__Junction__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__Junction__Sequence__copy(
  const maliput_ros_interfaces__msg__Junction__Sequence * input,
  maliput_ros_interfaces__msg__Junction__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__Junction);
    maliput_ros_interfaces__msg__Junction * data =
      (maliput_ros_interfaces__msg__Junction *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__Junction__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__Junction__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__Junction__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
