// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/LaneEnd.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE_END__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE_END__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'lane_id'
#include "maliput_ros_interfaces/msg/detail/lane_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__LaneEnd __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__LaneEnd __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LaneEnd_
{
  using Type = LaneEnd_<ContainerAllocator>;

  explicit LaneEnd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->end = 0l;
    }
  }

  explicit LaneEnd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->end = 0l;
    }
  }

  // field types and members
  using _lane_id_type =
    maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>;
  _lane_id_type lane_id;
  using _end_type =
    int32_t;
  _end_type end;

  // setters for named parameter idiom
  Type & set__lane_id(
    const maliput_ros_interfaces::msg::LaneId_<ContainerAllocator> & _arg)
  {
    this->lane_id = _arg;
    return *this;
  }
  Type & set__end(
    const int32_t & _arg)
  {
    this->end = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t WHICHSTART =
    0;
  static constexpr int32_t WHICHFINISH =
    1;

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__LaneEnd
    std::shared_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__LaneEnd
    std::shared_ptr<maliput_ros_interfaces::msg::LaneEnd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LaneEnd_ & other) const
  {
    if (this->lane_id != other.lane_id) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    return true;
  }
  bool operator!=(const LaneEnd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LaneEnd_

// alias to use template instance with default allocator
using LaneEnd =
  maliput_ros_interfaces::msg::LaneEnd_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int32_t LaneEnd_<ContainerAllocator>::WHICHSTART;
template<typename ContainerAllocator>
constexpr int32_t LaneEnd_<ContainerAllocator>::WHICHFINISH;

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__LANE_END__STRUCT_HPP_
