// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/RoadGeometry.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'id'
#include "maliput_ros_interfaces/msg/detail/road_geometry_id__struct.hpp"
// Member 'junction_ids'
#include "maliput_ros_interfaces/msg/detail/junction_id__struct.hpp"
// Member 'branch_point_ids'
#include "maliput_ros_interfaces/msg/detail/branch_point_id__struct.hpp"
// Member 'inertial_to_backend_frame_translation'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__RoadGeometry __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__RoadGeometry __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadGeometry_
{
  using Type = RoadGeometry_<ContainerAllocator>;

  explicit RoadGeometry_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_init),
    inertial_to_backend_frame_translation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->linear_tolerance = 0.0;
      this->angular_tolerance = 0.0;
      this->scale_length = 0.0;
    }
  }

  explicit RoadGeometry_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc, _init),
    inertial_to_backend_frame_translation(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->linear_tolerance = 0.0;
      this->angular_tolerance = 0.0;
      this->scale_length = 0.0;
    }
  }

  // field types and members
  using _id_type =
    maliput_ros_interfaces::msg::RoadGeometryId_<ContainerAllocator>;
  _id_type id;
  using _junction_ids_type =
    std::vector<maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator>>::other>;
  _junction_ids_type junction_ids;
  using _branch_point_ids_type =
    std::vector<maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>>::other>;
  _branch_point_ids_type branch_point_ids;
  using _linear_tolerance_type =
    double;
  _linear_tolerance_type linear_tolerance;
  using _angular_tolerance_type =
    double;
  _angular_tolerance_type angular_tolerance;
  using _scale_length_type =
    double;
  _scale_length_type scale_length;
  using _inertial_to_backend_frame_translation_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _inertial_to_backend_frame_translation_type inertial_to_backend_frame_translation;

  // setters for named parameter idiom
  Type & set__id(
    const maliput_ros_interfaces::msg::RoadGeometryId_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__junction_ids(
    const std::vector<maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator>>::other> & _arg)
  {
    this->junction_ids = _arg;
    return *this;
  }
  Type & set__branch_point_ids(
    const std::vector<maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::BranchPointId_<ContainerAllocator>>::other> & _arg)
  {
    this->branch_point_ids = _arg;
    return *this;
  }
  Type & set__linear_tolerance(
    const double & _arg)
  {
    this->linear_tolerance = _arg;
    return *this;
  }
  Type & set__angular_tolerance(
    const double & _arg)
  {
    this->angular_tolerance = _arg;
    return *this;
  }
  Type & set__scale_length(
    const double & _arg)
  {
    this->scale_length = _arg;
    return *this;
  }
  Type & set__inertial_to_backend_frame_translation(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->inertial_to_backend_frame_translation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadGeometry
    std::shared_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadGeometry
    std::shared_ptr<maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadGeometry_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->junction_ids != other.junction_ids) {
      return false;
    }
    if (this->branch_point_ids != other.branch_point_ids) {
      return false;
    }
    if (this->linear_tolerance != other.linear_tolerance) {
      return false;
    }
    if (this->angular_tolerance != other.angular_tolerance) {
      return false;
    }
    if (this->scale_length != other.scale_length) {
      return false;
    }
    if (this->inertial_to_backend_frame_translation != other.inertial_to_backend_frame_translation) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadGeometry_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadGeometry_

// alias to use template instance with default allocator
using RoadGeometry =
  maliput_ros_interfaces::msg::RoadGeometry_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_
