// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/RoadPosition.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'lane_id'
#include "maliput_ros_interfaces/msg/detail/lane_id__struct.hpp"
// Member 'pos'
#include "maliput_ros_interfaces/msg/detail/lane_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__RoadPosition __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__RoadPosition __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadPosition_
{
  using Type = RoadPosition_<ContainerAllocator>;

  explicit RoadPosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_init),
    pos(_init)
  {
    (void)_init;
  }

  explicit RoadPosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_id(_alloc, _init),
    pos(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _lane_id_type =
    maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>;
  _lane_id_type lane_id;
  using _pos_type =
    maliput_ros_interfaces::msg::LanePosition_<ContainerAllocator>;
  _pos_type pos;

  // setters for named parameter idiom
  Type & set__lane_id(
    const maliput_ros_interfaces::msg::LaneId_<ContainerAllocator> & _arg)
  {
    this->lane_id = _arg;
    return *this;
  }
  Type & set__pos(
    const maliput_ros_interfaces::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->pos = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadPosition
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__RoadPosition
    std::shared_ptr<maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadPosition_ & other) const
  {
    if (this->lane_id != other.lane_id) {
      return false;
    }
    if (this->pos != other.pos) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadPosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadPosition_

// alias to use template instance with default allocator
using RoadPosition =
  maliput_ros_interfaces::msg::RoadPosition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__ROAD_POSITION__STRUCT_HPP_
