// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:msg/RoadPositionResult.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/msg/detail/road_position_result__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `road_position`
#include "maliput_ros_interfaces/msg/detail/road_position__functions.h"
// Member `nearest_position`
#include "maliput_ros_interfaces/msg/detail/inertial_position__functions.h"

bool
maliput_ros_interfaces__msg__RoadPositionResult__init(maliput_ros_interfaces__msg__RoadPositionResult * msg)
{
  if (!msg) {
    return false;
  }
  // road_position
  if (!maliput_ros_interfaces__msg__RoadPosition__init(&msg->road_position)) {
    maliput_ros_interfaces__msg__RoadPositionResult__fini(msg);
    return false;
  }
  // nearest_position
  if (!maliput_ros_interfaces__msg__InertialPosition__init(&msg->nearest_position)) {
    maliput_ros_interfaces__msg__RoadPositionResult__fini(msg);
    return false;
  }
  // distance
  return true;
}

void
maliput_ros_interfaces__msg__RoadPositionResult__fini(maliput_ros_interfaces__msg__RoadPositionResult * msg)
{
  if (!msg) {
    return;
  }
  // road_position
  maliput_ros_interfaces__msg__RoadPosition__fini(&msg->road_position);
  // nearest_position
  maliput_ros_interfaces__msg__InertialPosition__fini(&msg->nearest_position);
  // distance
}

bool
maliput_ros_interfaces__msg__RoadPositionResult__are_equal(const maliput_ros_interfaces__msg__RoadPositionResult * lhs, const maliput_ros_interfaces__msg__RoadPositionResult * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // road_position
  if (!maliput_ros_interfaces__msg__RoadPosition__are_equal(
      &(lhs->road_position), &(rhs->road_position)))
  {
    return false;
  }
  // nearest_position
  if (!maliput_ros_interfaces__msg__InertialPosition__are_equal(
      &(lhs->nearest_position), &(rhs->nearest_position)))
  {
    return false;
  }
  // distance
  if (lhs->distance != rhs->distance) {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__msg__RoadPositionResult__copy(
  const maliput_ros_interfaces__msg__RoadPositionResult * input,
  maliput_ros_interfaces__msg__RoadPositionResult * output)
{
  if (!input || !output) {
    return false;
  }
  // road_position
  if (!maliput_ros_interfaces__msg__RoadPosition__copy(
      &(input->road_position), &(output->road_position)))
  {
    return false;
  }
  // nearest_position
  if (!maliput_ros_interfaces__msg__InertialPosition__copy(
      &(input->nearest_position), &(output->nearest_position)))
  {
    return false;
  }
  // distance
  output->distance = input->distance;
  return true;
}

maliput_ros_interfaces__msg__RoadPositionResult *
maliput_ros_interfaces__msg__RoadPositionResult__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__RoadPositionResult * msg = (maliput_ros_interfaces__msg__RoadPositionResult *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__RoadPositionResult), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__msg__RoadPositionResult));
  bool success = maliput_ros_interfaces__msg__RoadPositionResult__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__msg__RoadPositionResult__destroy(maliput_ros_interfaces__msg__RoadPositionResult * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__msg__RoadPositionResult__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__init(maliput_ros_interfaces__msg__RoadPositionResult__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__RoadPositionResult * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__msg__RoadPositionResult *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__msg__RoadPositionResult), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__msg__RoadPositionResult__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__msg__RoadPositionResult__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__fini(maliput_ros_interfaces__msg__RoadPositionResult__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__msg__RoadPositionResult__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__msg__RoadPositionResult__Sequence *
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__msg__RoadPositionResult__Sequence * array = (maliput_ros_interfaces__msg__RoadPositionResult__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__msg__RoadPositionResult__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__msg__RoadPositionResult__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__destroy(maliput_ros_interfaces__msg__RoadPositionResult__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__msg__RoadPositionResult__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__are_equal(const maliput_ros_interfaces__msg__RoadPositionResult__Sequence * lhs, const maliput_ros_interfaces__msg__RoadPositionResult__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__msg__RoadPositionResult__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__msg__RoadPositionResult__Sequence__copy(
  const maliput_ros_interfaces__msg__RoadPositionResult__Sequence * input,
  maliput_ros_interfaces__msg__RoadPositionResult__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__msg__RoadPositionResult);
    maliput_ros_interfaces__msg__RoadPositionResult * data =
      (maliput_ros_interfaces__msg__RoadPositionResult *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__msg__RoadPositionResult__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__msg__RoadPositionResult__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__msg__RoadPositionResult__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
