// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:msg/Segment.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__MSG__DETAIL__SEGMENT__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__MSG__DETAIL__SEGMENT__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'id'
#include "maliput_ros_interfaces/msg/detail/segment_id__struct.hpp"
// Member 'junction_id'
#include "maliput_ros_interfaces/msg/detail/junction_id__struct.hpp"
// Member 'lane_ids'
#include "maliput_ros_interfaces/msg/detail/lane_id__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__msg__Segment __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__msg__Segment __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Segment_
{
  using Type = Segment_<ContainerAllocator>;

  explicit Segment_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_init),
    junction_id(_init)
  {
    (void)_init;
  }

  explicit Segment_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : id(_alloc, _init),
    junction_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _id_type =
    maliput_ros_interfaces::msg::SegmentId_<ContainerAllocator>;
  _id_type id;
  using _junction_id_type =
    maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator>;
  _junction_id_type junction_id;
  using _lane_ids_type =
    std::vector<maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>>::other>;
  _lane_ids_type lane_ids;

  // setters for named parameter idiom
  Type & set__id(
    const maliput_ros_interfaces::msg::SegmentId_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__junction_id(
    const maliput_ros_interfaces::msg::JunctionId_<ContainerAllocator> & _arg)
  {
    this->junction_id = _arg;
    return *this;
  }
  Type & set__lane_ids(
    const std::vector<maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::LaneId_<ContainerAllocator>>::other> & _arg)
  {
    this->lane_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::msg::Segment_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::msg::Segment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::Segment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::msg::Segment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__msg__Segment
    std::shared_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__msg__Segment
    std::shared_ptr<maliput_ros_interfaces::msg::Segment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Segment_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->junction_id != other.junction_id) {
      return false;
    }
    if (this->lane_ids != other.lane_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const Segment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Segment_

// alias to use template instance with default allocator
using Segment =
  maliput_ros_interfaces::msg::Segment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__MSG__DETAIL__SEGMENT__STRUCT_HPP_
