// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:srv/DeriveLaneSRoutes.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/srv/detail/derive_lane_s_routes__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `start`
// Member `end`
#include "maliput_ros_interfaces/msg/detail/road_position__functions.h"

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__init(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * msg)
{
  if (!msg) {
    return false;
  }
  // start
  if (!maliput_ros_interfaces__msg__RoadPosition__init(&msg->start)) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(msg);
    return false;
  }
  // end
  if (!maliput_ros_interfaces__msg__RoadPosition__init(&msg->end)) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(msg);
    return false;
  }
  // max_length_m
  return true;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * msg)
{
  if (!msg) {
    return;
  }
  // start
  maliput_ros_interfaces__msg__RoadPosition__fini(&msg->start);
  // end
  maliput_ros_interfaces__msg__RoadPosition__fini(&msg->end);
  // max_length_m
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__are_equal(const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * lhs, const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // start
  if (!maliput_ros_interfaces__msg__RoadPosition__are_equal(
      &(lhs->start), &(rhs->start)))
  {
    return false;
  }
  // end
  if (!maliput_ros_interfaces__msg__RoadPosition__are_equal(
      &(lhs->end), &(rhs->end)))
  {
    return false;
  }
  // max_length_m
  if (lhs->max_length_m != rhs->max_length_m) {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__copy(
  const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * input,
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // start
  if (!maliput_ros_interfaces__msg__RoadPosition__copy(
      &(input->start), &(output->start)))
  {
    return false;
  }
  // end
  if (!maliput_ros_interfaces__msg__RoadPosition__copy(
      &(input->end), &(output->end)))
  {
    return false;
  }
  // max_length_m
  output->max_length_m = input->max_length_m;
  return true;
}

maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request *
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * msg = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request));
  bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__destroy(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__init(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__fini(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence *
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * array = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__destroy(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__are_equal(const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * lhs, const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence__copy(
  const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * input,
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request);
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request * data =
      (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `lane_s_routes`
#include "maliput_ros_interfaces/msg/detail/lane_s_route__functions.h"

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__init(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * msg)
{
  if (!msg) {
    return false;
  }
  // lane_s_routes
  if (!maliput_ros_interfaces__msg__LaneSRoute__Sequence__init(&msg->lane_s_routes, 0)) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(msg);
    return false;
  }
  return true;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * msg)
{
  if (!msg) {
    return;
  }
  // lane_s_routes
  maliput_ros_interfaces__msg__LaneSRoute__Sequence__fini(&msg->lane_s_routes);
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__are_equal(const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * lhs, const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lane_s_routes
  if (!maliput_ros_interfaces__msg__LaneSRoute__Sequence__are_equal(
      &(lhs->lane_s_routes), &(rhs->lane_s_routes)))
  {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__copy(
  const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * input,
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // lane_s_routes
  if (!maliput_ros_interfaces__msg__LaneSRoute__Sequence__copy(
      &(input->lane_s_routes), &(output->lane_s_routes)))
  {
    return false;
  }
  return true;
}

maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response *
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * msg = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response));
  bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__destroy(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__init(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__fini(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence *
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * array = (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__destroy(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__are_equal(const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * lhs, const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence__copy(
  const maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * input,
  maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response);
    maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response * data =
      (maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__srv__DeriveLaneSRoutes_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
