// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/EvalMotionDerivatives.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__EVAL_MOTION_DERIVATIVES__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__EVAL_MOTION_DERIVATIVES__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'road_position'
#include "maliput_ros_interfaces/msg/detail/road_position__struct.hpp"
// Member 'velocity'
#include "maliput_ros_interfaces/msg/detail/iso_lane_velocity__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct EvalMotionDerivatives_Request_
{
  using Type = EvalMotionDerivatives_Request_<ContainerAllocator>;

  explicit EvalMotionDerivatives_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_init),
    velocity(_init)
  {
    (void)_init;
  }

  explicit EvalMotionDerivatives_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_alloc, _init),
    velocity(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_position_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _road_position_type road_position;
  using _velocity_type =
    maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator>;
  _velocity_type velocity;

  // setters for named parameter idiom
  Type & set__road_position(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->road_position = _arg;
    return *this;
  }
  Type & set__velocity(
    const maliput_ros_interfaces::msg::IsoLaneVelocity_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Request
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Request
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EvalMotionDerivatives_Request_ & other) const
  {
    if (this->road_position != other.road_position) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const EvalMotionDerivatives_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EvalMotionDerivatives_Request_

// alias to use template instance with default allocator
using EvalMotionDerivatives_Request =
  maliput_ros_interfaces::srv::EvalMotionDerivatives_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'lane_derivatives'
#include "maliput_ros_interfaces/msg/detail/lane_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct EvalMotionDerivatives_Response_
{
  using Type = EvalMotionDerivatives_Response_<ContainerAllocator>;

  explicit EvalMotionDerivatives_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_derivatives(_init)
  {
    (void)_init;
  }

  explicit EvalMotionDerivatives_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : lane_derivatives(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _lane_derivatives_type =
    maliput_ros_interfaces::msg::LanePosition_<ContainerAllocator>;
  _lane_derivatives_type lane_derivatives;

  // setters for named parameter idiom
  Type & set__lane_derivatives(
    const maliput_ros_interfaces::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->lane_derivatives = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Response
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__EvalMotionDerivatives_Response
    std::shared_ptr<maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EvalMotionDerivatives_Response_ & other) const
  {
    if (this->lane_derivatives != other.lane_derivatives) {
      return false;
    }
    return true;
  }
  bool operator!=(const EvalMotionDerivatives_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EvalMotionDerivatives_Response_

// alias to use template instance with default allocator
using EvalMotionDerivatives_Response =
  maliput_ros_interfaces::srv::EvalMotionDerivatives_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct EvalMotionDerivatives
{
  using Request = maliput_ros_interfaces::srv::EvalMotionDerivatives_Request;
  using Response = maliput_ros_interfaces::srv::EvalMotionDerivatives_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__EVAL_MOTION_DERIVATIVES__STRUCT_HPP_
