// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from maliput_ros_interfaces:srv/FindRoadPositions.idl
// generated code does not contain a copyright notice
#include "maliput_ros_interfaces/srv/detail/find_road_positions__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `inertial_position`
#include "maliput_ros_interfaces/msg/detail/inertial_position__functions.h"

bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__init(maliput_ros_interfaces__srv__FindRoadPositions_Request * msg)
{
  if (!msg) {
    return false;
  }
  // inertial_position
  if (!maliput_ros_interfaces__msg__InertialPosition__init(&msg->inertial_position)) {
    maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(msg);
    return false;
  }
  // radius
  return true;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(maliput_ros_interfaces__srv__FindRoadPositions_Request * msg)
{
  if (!msg) {
    return;
  }
  // inertial_position
  maliput_ros_interfaces__msg__InertialPosition__fini(&msg->inertial_position);
  // radius
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__are_equal(const maliput_ros_interfaces__srv__FindRoadPositions_Request * lhs, const maliput_ros_interfaces__srv__FindRoadPositions_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // inertial_position
  if (!maliput_ros_interfaces__msg__InertialPosition__are_equal(
      &(lhs->inertial_position), &(rhs->inertial_position)))
  {
    return false;
  }
  // radius
  if (lhs->radius != rhs->radius) {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__copy(
  const maliput_ros_interfaces__srv__FindRoadPositions_Request * input,
  maliput_ros_interfaces__srv__FindRoadPositions_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // inertial_position
  if (!maliput_ros_interfaces__msg__InertialPosition__copy(
      &(input->inertial_position), &(output->inertial_position)))
  {
    return false;
  }
  // radius
  output->radius = input->radius;
  return true;
}

maliput_ros_interfaces__srv__FindRoadPositions_Request *
maliput_ros_interfaces__srv__FindRoadPositions_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Request * msg = (maliput_ros_interfaces__srv__FindRoadPositions_Request *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Request));
  bool success = maliput_ros_interfaces__srv__FindRoadPositions_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Request__destroy(maliput_ros_interfaces__srv__FindRoadPositions_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__init(maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Request * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__srv__FindRoadPositions_Request *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__srv__FindRoadPositions_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__fini(maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence *
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * array = (maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__destroy(maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__are_equal(const maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * lhs, const maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__srv__FindRoadPositions_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence__copy(
  const maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * input,
  maliput_ros_interfaces__srv__FindRoadPositions_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Request);
    maliput_ros_interfaces__srv__FindRoadPositions_Request * data =
      (maliput_ros_interfaces__srv__FindRoadPositions_Request *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__srv__FindRoadPositions_Request__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__srv__FindRoadPositions_Request__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__srv__FindRoadPositions_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `road_position_results`
#include "maliput_ros_interfaces/msg/detail/road_position_result__functions.h"

bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__init(maliput_ros_interfaces__srv__FindRoadPositions_Response * msg)
{
  if (!msg) {
    return false;
  }
  // road_position_results
  if (!maliput_ros_interfaces__msg__RoadPositionResult__Sequence__init(&msg->road_position_results, 0)) {
    maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(msg);
    return false;
  }
  return true;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(maliput_ros_interfaces__srv__FindRoadPositions_Response * msg)
{
  if (!msg) {
    return;
  }
  // road_position_results
  maliput_ros_interfaces__msg__RoadPositionResult__Sequence__fini(&msg->road_position_results);
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__are_equal(const maliput_ros_interfaces__srv__FindRoadPositions_Response * lhs, const maliput_ros_interfaces__srv__FindRoadPositions_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // road_position_results
  if (!maliput_ros_interfaces__msg__RoadPositionResult__Sequence__are_equal(
      &(lhs->road_position_results), &(rhs->road_position_results)))
  {
    return false;
  }
  return true;
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__copy(
  const maliput_ros_interfaces__srv__FindRoadPositions_Response * input,
  maliput_ros_interfaces__srv__FindRoadPositions_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // road_position_results
  if (!maliput_ros_interfaces__msg__RoadPositionResult__Sequence__copy(
      &(input->road_position_results), &(output->road_position_results)))
  {
    return false;
  }
  return true;
}

maliput_ros_interfaces__srv__FindRoadPositions_Response *
maliput_ros_interfaces__srv__FindRoadPositions_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Response * msg = (maliput_ros_interfaces__srv__FindRoadPositions_Response *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Response));
  bool success = maliput_ros_interfaces__srv__FindRoadPositions_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Response__destroy(maliput_ros_interfaces__srv__FindRoadPositions_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__init(maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Response * data = NULL;

  if (size) {
    data = (maliput_ros_interfaces__srv__FindRoadPositions_Response *)allocator.zero_allocate(size, sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = maliput_ros_interfaces__srv__FindRoadPositions_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__fini(maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence *
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * array = (maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence *)allocator.allocate(sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__destroy(maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__are_equal(const maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * lhs, const maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!maliput_ros_interfaces__srv__FindRoadPositions_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence__copy(
  const maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * input,
  maliput_ros_interfaces__srv__FindRoadPositions_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(maliput_ros_interfaces__srv__FindRoadPositions_Response);
    maliput_ros_interfaces__srv__FindRoadPositions_Response * data =
      (maliput_ros_interfaces__srv__FindRoadPositions_Response *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!maliput_ros_interfaces__srv__FindRoadPositions_Response__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          maliput_ros_interfaces__srv__FindRoadPositions_Response__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!maliput_ros_interfaces__srv__FindRoadPositions_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
