// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/FindRoadPositions.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__FIND_ROAD_POSITIONS__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__FIND_ROAD_POSITIONS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'inertial_position'
#include "maliput_ros_interfaces/msg/detail/inertial_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct FindRoadPositions_Request_
{
  using Type = FindRoadPositions_Request_<ContainerAllocator>;

  explicit FindRoadPositions_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : inertial_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->radius = 0.0;
    }
  }

  explicit FindRoadPositions_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : inertial_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->radius = 0.0;
    }
  }

  // field types and members
  using _inertial_position_type =
    maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>;
  _inertial_position_type inertial_position;
  using _radius_type =
    double;
  _radius_type radius;

  // setters for named parameter idiom
  Type & set__inertial_position(
    const maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator> & _arg)
  {
    this->inertial_position = _arg;
    return *this;
  }
  Type & set__radius(
    const double & _arg)
  {
    this->radius = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Request
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Request
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FindRoadPositions_Request_ & other) const
  {
    if (this->inertial_position != other.inertial_position) {
      return false;
    }
    if (this->radius != other.radius) {
      return false;
    }
    return true;
  }
  bool operator!=(const FindRoadPositions_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FindRoadPositions_Request_

// alias to use template instance with default allocator
using FindRoadPositions_Request =
  maliput_ros_interfaces::srv::FindRoadPositions_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'road_position_results'
#include "maliput_ros_interfaces/msg/detail/road_position_result__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct FindRoadPositions_Response_
{
  using Type = FindRoadPositions_Response_<ContainerAllocator>;

  explicit FindRoadPositions_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit FindRoadPositions_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _road_position_results_type =
    std::vector<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>::other>;
  _road_position_results_type road_position_results;

  // setters for named parameter idiom
  Type & set__road_position_results(
    const std::vector<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>, typename ContainerAllocator::template rebind<maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>>::other> & _arg)
  {
    this->road_position_results = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Response
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__FindRoadPositions_Response
    std::shared_ptr<maliput_ros_interfaces::srv::FindRoadPositions_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FindRoadPositions_Response_ & other) const
  {
    if (this->road_position_results != other.road_position_results) {
      return false;
    }
    return true;
  }
  bool operator!=(const FindRoadPositions_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FindRoadPositions_Response_

// alias to use template instance with default allocator
using FindRoadPositions_Response =
  maliput_ros_interfaces::srv::FindRoadPositions_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct FindRoadPositions
{
  using Request = maliput_ros_interfaces::srv::FindRoadPositions_Request;
  using Response = maliput_ros_interfaces::srv::FindRoadPositions_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__FIND_ROAD_POSITIONS__STRUCT_HPP_
