// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/RoadGeometry.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RoadGeometry_Request_
{
  using Type = RoadGeometry_Request_<ContainerAllocator>;

  explicit RoadGeometry_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit RoadGeometry_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Request
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Request
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadGeometry_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadGeometry_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadGeometry_Request_

// alias to use template instance with default allocator
using RoadGeometry_Request =
  maliput_ros_interfaces::srv::RoadGeometry_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'road_geometry'
#include "maliput_ros_interfaces/msg/detail/road_geometry__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RoadGeometry_Response_
{
  using Type = RoadGeometry_Response_<ContainerAllocator>;

  explicit RoadGeometry_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_geometry(_init)
  {
    (void)_init;
  }

  explicit RoadGeometry_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_geometry(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_geometry_type =
    maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator>;
  _road_geometry_type road_geometry;

  // setters for named parameter idiom
  Type & set__road_geometry(
    const maliput_ros_interfaces::msg::RoadGeometry_<ContainerAllocator> & _arg)
  {
    this->road_geometry = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Response
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__RoadGeometry_Response
    std::shared_ptr<maliput_ros_interfaces::srv::RoadGeometry_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadGeometry_Response_ & other) const
  {
    if (this->road_geometry != other.road_geometry) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadGeometry_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadGeometry_Response_

// alias to use template instance with default allocator
using RoadGeometry_Response =
  maliput_ros_interfaces::srv::RoadGeometry_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct RoadGeometry
{
  using Request = maliput_ros_interfaces::srv::RoadGeometry_Request;
  using Response = maliput_ros_interfaces::srv::RoadGeometry_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__ROAD_GEOMETRY__STRUCT_HPP_
