// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/ToInertialPose.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_INERTIAL_POSE__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_INERTIAL_POSE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'road_position'
#include "maliput_ros_interfaces/msg/detail/road_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ToInertialPose_Request_
{
  using Type = ToInertialPose_Request_<ContainerAllocator>;

  explicit ToInertialPose_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_init)
  {
    (void)_init;
  }

  explicit ToInertialPose_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_position_type =
    maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator>;
  _road_position_type road_position;

  // setters for named parameter idiom
  Type & set__road_position(
    const maliput_ros_interfaces::msg::RoadPosition_<ContainerAllocator> & _arg)
  {
    this->road_position = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Request
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Request
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ToInertialPose_Request_ & other) const
  {
    if (this->road_position != other.road_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const ToInertialPose_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ToInertialPose_Request_

// alias to use template instance with default allocator
using ToInertialPose_Request =
  maliput_ros_interfaces::srv::ToInertialPose_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'position'
#include "maliput_ros_interfaces/msg/detail/inertial_position__struct.hpp"
// Member 'orientation'
#include "maliput_ros_interfaces/msg/detail/rotation__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ToInertialPose_Response_
{
  using Type = ToInertialPose_Response_<ContainerAllocator>;

  explicit ToInertialPose_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_init),
    orientation(_init)
  {
    (void)_init;
  }

  explicit ToInertialPose_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : position(_alloc, _init),
    orientation(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _position_type =
    maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>;
  _position_type position;
  using _orientation_type =
    maliput_ros_interfaces::msg::Rotation_<ContainerAllocator>;
  _orientation_type orientation;

  // setters for named parameter idiom
  Type & set__position(
    const maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__orientation(
    const maliput_ros_interfaces::msg::Rotation_<ContainerAllocator> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Response
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToInertialPose_Response
    std::shared_ptr<maliput_ros_interfaces::srv::ToInertialPose_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ToInertialPose_Response_ & other) const
  {
    if (this->position != other.position) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    return true;
  }
  bool operator!=(const ToInertialPose_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ToInertialPose_Response_

// alias to use template instance with default allocator
using ToInertialPose_Response =
  maliput_ros_interfaces::srv::ToInertialPose_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct ToInertialPose
{
  using Request = maliput_ros_interfaces::srv::ToInertialPose_Request;
  using Response = maliput_ros_interfaces::srv::ToInertialPose_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_INERTIAL_POSE__STRUCT_HPP_
