// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from maliput_ros_interfaces:srv/ToRoadPosition.idl
// generated code does not contain a copyright notice

#ifndef MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_ROAD_POSITION__STRUCT_HPP_
#define MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_ROAD_POSITION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'inertial_position'
#include "maliput_ros_interfaces/msg/detail/inertial_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Request __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Request __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ToRoadPosition_Request_
{
  using Type = ToRoadPosition_Request_<ContainerAllocator>;

  explicit ToRoadPosition_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : inertial_position(_init)
  {
    (void)_init;
  }

  explicit ToRoadPosition_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : inertial_position(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _inertial_position_type =
    maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator>;
  _inertial_position_type inertial_position;

  // setters for named parameter idiom
  Type & set__inertial_position(
    const maliput_ros_interfaces::msg::InertialPosition_<ContainerAllocator> & _arg)
  {
    this->inertial_position = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Request
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Request
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ToRoadPosition_Request_ & other) const
  {
    if (this->inertial_position != other.inertial_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const ToRoadPosition_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ToRoadPosition_Request_

// alias to use template instance with default allocator
using ToRoadPosition_Request =
  maliput_ros_interfaces::srv::ToRoadPosition_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces


// Include directives for member types
// Member 'road_position_result'
#include "maliput_ros_interfaces/msg/detail/road_position_result__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Response __attribute__((deprecated))
#else
# define DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Response __declspec(deprecated)
#endif

namespace maliput_ros_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ToRoadPosition_Response_
{
  using Type = ToRoadPosition_Response_<ContainerAllocator>;

  explicit ToRoadPosition_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position_result(_init)
  {
    (void)_init;
  }

  explicit ToRoadPosition_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_position_result(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_position_result_type =
    maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator>;
  _road_position_result_type road_position_result;

  // setters for named parameter idiom
  Type & set__road_position_result(
    const maliput_ros_interfaces::msg::RoadPositionResult_<ContainerAllocator> & _arg)
  {
    this->road_position_result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Response
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__maliput_ros_interfaces__srv__ToRoadPosition_Response
    std::shared_ptr<maliput_ros_interfaces::srv::ToRoadPosition_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ToRoadPosition_Response_ & other) const
  {
    if (this->road_position_result != other.road_position_result) {
      return false;
    }
    return true;
  }
  bool operator!=(const ToRoadPosition_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ToRoadPosition_Response_

// alias to use template instance with default allocator
using ToRoadPosition_Response =
  maliput_ros_interfaces::srv::ToRoadPosition_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace maliput_ros_interfaces

namespace maliput_ros_interfaces
{

namespace srv
{

struct ToRoadPosition
{
  using Request = maliput_ros_interfaces::srv::ToRoadPosition_Request;
  using Response = maliput_ros_interfaces::srv::ToRoadPosition_Response;
};

}  // namespace srv

}  // namespace maliput_ros_interfaces

#endif  // MALIPUT_ROS_INTERFACES__SRV__DETAIL__TO_ROAD_POSITION__STRUCT_HPP_
